Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | List of all members
Whirlpool Class Reference

Whirlpool message digest. More...

Inheritance diagram for Whirlpool:

## Public Member Functions
std::string | AlgorithmProvider () const
| The Whirlpool hashing function. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
Public Member Functions inherited from IteratedHashWithStaticTransform< word64, BigEndian, 64, 64, Whirlpool >
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
Public Member Functions inherited from ClonableImpl< Whirlpool, AlgorithmImpl< IteratedHash< word64, BigEndian, T_BlockSize >, Whirlpool > >
Clonable * | Clone () const
| Create a copy of this object. More...
Public Member Functions inherited from AlgorithmImpl< IteratedHash< word64, BigEndian, T_BlockSize >, Whirlpool >
std::string | AlgorithmName () const
| The algorithm name. More...
Public Member Functions inherited from IteratedHash< word64, BigEndian, T_BlockSize >
unsigned int | BlockSize () const
| Provides the block size of the hash. More...
ByteOrder | GetByteOrder () const
| Provides the byte order of the hash. More...
void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
| Adjusts the byte ordering of the hash. More...
Public Member Functions inherited from IteratedHashBase< word64, HashTransformation >
| IteratedHashBase ()
| Construct an IteratedHashBase.
unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
byte * | CreateUpdateSpace (size_t &size)
| Requests space which can be written into by the caller. More...
void | Restart ()
| Restart the hash. More...
void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...

## Static Public Member Functions
static const char * | StaticAlgorithmName ()
static void | InitState (HashWordType *state)
static void | Transform (word64 *digest, const word64 *data)
Static Public Member Functions inherited from AlgorithmImpl< IteratedHash< word64, BigEndian, T_BlockSize >, Whirlpool >
static std::string CRYPTOPP_API | StaticAlgorithmName ()
| The algorithm name. More...

## Additional Inherited Members
Public Types inherited from IteratedHash< word64, BigEndian, T_BlockSize >
typedef BigEndian | ByteOrderClass
typedef word64 | HashWordType
Public Types inherited from IteratedHashBase< word64, HashTransformation >
typedef word64 | HashWordType
Static Public Attributes inherited from IteratedHashWithStaticTransform< word64, BigEndian, 64, 64, Whirlpool >
static const int | DIGESTSIZE
Static Public Attributes inherited from IteratedHash< word64, BigEndian, T_BlockSize >
static const int | BLOCKSIZE

## Detailed Description

Whirlpool message digest.

Crypto++ provides version 3.0 of the Whirlpool algorithm. This version of the algorithm was submitted for ISO standardization.

Since
  Crypto++ 5.2

See also
  Whirlpool

Definition at line 29 of file whrlpool.h.

## Member Function Documentation

## ◆ AlgorithmProvider()

std::string Whirlpool::AlgorithmProvider | ( |  | ) | const
| virtual

The Whirlpool hashing function.

References

The Whirlpool algorithm was developed by Paulo S. L. M. Barreto and Vincent Rijmen.

See P.S.L.M. Barreto, V. Rijmen, ``The Whirlpool hashing function,'' NESSIE submission, 2000 (tweaked version, 2001), https://www.cosic.esat.kuleuven.ac.be/nessie/workshop/submissions/whirlpool.zip

Author
  Paulo S.L.M. Barreto
  Vincent Rijmen.

Version
  3.0 (2003.03.12)

=============================================================================

Differences from version 2.1:

- Suboptimal diffusion matrix replaced by cir(1, 1, 4, 1, 8, 5, 2, 9).

=============================================================================

Differences from version 2.0:

- Generation of ISO/IEC 10118-3 test vectors.
- Bug fix: nonzero carry was ignored when tallying the data length (this bug apparently only manifested itself when feeding data in pieces rather than in a single chunk at once).
- Support for MS Visual C++ 64-bit integer arithmetic.

Differences from version 1.0:

- Original S-box replaced by the tweaked, hardware-efficient version.

=============================================================================

THIS SOFTWARE IS PROVIDED BY THE AUTHORS ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Reimplemented from IteratedHashBase< word64, HashTransformation >.

Definition at line 92 of file whrlpool.cpp.

## ◆ TruncatedFinal()

void Whirlpool::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |
| virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() call Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Implements HashTransformation.

Definition at line 106 of file whrlpool.cpp.

The documentation for this class was generated from the following files:

- whrlpool.h
- whrlpool.cpp